Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.uima.analysis_engine.annotator
Interface AnnotatorContext

    public interface AnnotatorContext

This interface is maintained only for backwards compatibility with annotators developed in UIMA SDK v1.x. New code should use `UimaContext` instead.

Method Summary
`String[]` | `getConfigParameterNames()` Gets the names of all configuration parameters that are not declared in a group.
`String[]` | `getConfigParameterNames(String aGroup)` Gets the names of all configuration parameters in the specified group.
`Object` | `getConfigParameterValue(String aParamName)` Retrieves the value for a configuration parameter that is not defined in any group or is defined in the default group.
`Object` | `getConfigParameterValue(String aGroupName, String aParamName)` Retrieves the value for a configuration parameter in a particular group.
`String[]` | `getConfigurationGroupNames()` Gets the names of all configuration parameter groups.
`String` | `getDataPath()` Gets the data path used to locate resources.
`InstrumentationFacility` | `getInstrumentationFacility()` Gets the `InstrumentationFacility` that this annotator can use to record information about its performance.
`Logger` | `getLogger()` Gets the `Logger` to which this annotator should send its log output.
`InputStream` | `getResourceAsStream(String aKey)` Retrieves an InputStream for reading from the named resource.
`InputStream` | `getResourceAsStream(String aKey, String[] aParams)` Retrieves an InputStream for reading from the named resource.
`String` | `getResourceFilePath(String aKey)` Retrieves the absolute file path to the named resource.
`String` | `getResourceFilePath(String aKey, String[] aParams)` Retrieves the absolute file path to the named resource.
`Object` | `getResourceObject(String aKey)` Retrieves the named resource object.
`Object` | `getResourceObject(String aKey, String[] aParams)` Retrieves the named resource object.
`URI` | `getResourceURI(String aKey)` Retrieves the URI to the named resource.
`URI` | `getResourceURI(String aKey, String[] aParams)` Retrieves the URI to the named resource.
`URL` | `getResourceURL(String aKey)` Retrieves the URL to the named resource.
`URL` | `getResourceURL(String aKey, String[] aParams)` Retrieves the URL to the named resource.
`SofaID[]` | `getSofaMappings()` Deprecated. As of v2.0, annotators no longer need to explicitly call this method. CAS views can now be obtained directly by the method `CAS.getView(String)`, and the framework will automatically do the necessary Sofa mappings.
`SofaID` | `mapToSofaID(String aSofaName)` Deprecated. As of v2.0, annotators no longer need to explicitly call this method. CAS views can now be obtained directly by the method `CAS.getView(String)`, and the framework will automatically do the necessary Sofa mappings.

Method Detail

### getConfigParameterValue

    Object getConfigParameterValue(String aParamName)
                                   throws AnnotatorContextException

  Retrieves the value for a configuration parameter that is not defined in any group or is defined in the default group.

  This method returns `null` if the parameter is optional and has not been assigned a value. (For mandatory parameters, an exception is thrown during initialization if no value has been assigned.) This method also returns `null` if there is no declared configuration parameter with the specified name.

  Parameters:
    `aParamName` - the name of the parameter to look up
  Returns:
    the value of the parameter with the given name. The annotator is expected to know the data type of its parameters. Returns `null` if the parameter does not exist or has not been assigned a value.
  Throws:
    `AnnotatorContextException` - if an internal failure has occurred in the `AnnotatorContext`.

### getConfigParameterValue

    Object getConfigParameterValue(String aGroupName,
                                   String aParamName)
                                   throws AnnotatorContextException

  Retrieves the value for a configuration parameter in a particular group. If that group contains no value for the specified parameter, the fallback strategy specified by the Analysis Engine's `ConfigurationParameterDeclarations.getSearchStrategy()` property will be used. The search strategy can be specified in the Analysis Engine Descriptor.

  This method returns `null` if the parameter is optional and has not been assigned a value. (For mandatory parameters, an exception is thrown during initialization if no value has been assigned.) This method also returns `null` if there is no declared configuration parameter with the specified name.

  Parameters:
    `aGroupName` - the name of the group containing the parameter
    `aParamName` - the name of the parameter to look up
  Returns:
    the value of the parameter with the given name. The annotator is expected to know the data type of its parameters. Returns `null` if the parameter does not exist or has not been assigned a value.
  Throws:
    `AnnotatorContextException` - if an internal failure has occurred in the `AnnotatorContext`.

### getConfigurationGroupNames

    String[] getConfigurationGroupNames()

  Gets the names of all configuration parameter groups.

  Returns:
    an array containing the names of all configuration groups that exist for this annotator. Returns an empty array if no groups are declared.

### getConfigParameterNames

    String[] getConfigParameterNames(String aGroup)

  Gets the names of all configuration parameters in the specified group.

  Parameters:
    `aGroup` - the group name
  Returns:
    an array containing the names of all configuration parameters declared in {`aGroup`. Note that this does include parameters with null values. Returns an empty array if there are none (including if the group does not exist).

### getConfigParameterNames

    String[] getConfigParameterNames()

  Gets the names of all configuration parameters that are not declared in a group.

  Returns:
    an array containing the names of all configuration parameters not declared in any group. Returns an empty array if there are none.

### getLogger

    Logger getLogger()
                     throws AnnotatorContextException

  Gets the `Logger` to which this annotator should send its log output. Annotators should use this facility rather than writing to their own log files (or to stdout).

  Returns:
    an instance of a logger for use by this annotator.
  Throws:
    `AnnotatorContextException` - if an internal failure has occurred in the `AnnotatorContext`.

### getInstrumentationFacility

    InstrumentationFacility getInstrumentationFacility()
                                                       throws AnnotatorContextException

  Gets the `InstrumentationFacility` that this annotator can use to record information about its performance.

  Returns:
    an instance of the instrumentation facility for use by this annotator.
  Throws:
    `AnnotatorContextException` - if an internal failure has occurred in the `AnnotatorContext`.

### getResourceURL

    URL getResourceURL(String aKey)
                       throws AnnotatorContextException

  Retrieves the URL to the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  Note that if the URL contains spaces may be encoded as %20. The `URL.getPath()` method does NOT decode these sequences, therefore it is not safe to call `getResourceURL().getPath()` and attempt to use the result as a file path. Instead, you may use `getResourceURI(String)` or `getResourceFilePath(String)`.

  For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
  Returns:
    the `URL` at which the named resource is located, `null` if the named resource could not be found.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceURL(String)`

### getResourceURI

    URI getResourceURI(String aKey)
                       throws AnnotatorContextException

  Retrieves the URI to the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  This method is safer than `getResourceURL(String)` in its treatment of file paths containing spaces. This is because the `URI.getPath()` does perform URL decoding of that path (decoding %20 sequences to spaces) whereas `URL.getPath()` does not.

  For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
  Returns:
    the `URI` at which the named resource is located, `null` if the named resource could not be found.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceURI(String)`

### getResourceFilePath

    String getResourceFilePath(String aKey)
                               throws AnnotatorContextException

  Retrieves the absolute file path to the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  This only works if the resource is a local file. If the resource is not a local file (for example, it could be an `http` URL, then an exception will be thrown.

  URL decoding will be done on the file path, so it is safe to use this method for file paths that contain spaces. For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
  Returns:
    the absolute file path at which the named resource is located, `null` if the named resource could not be found.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceFilePath(String)`

### getResourceAsStream

    InputStream getResourceAsStream(String aKey)
                                    throws AnnotatorContextException

  Retrieves an InputStream for reading from the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
  Returns:
    an `InputStream` for reading from the named resource, `null` if the named resource could not be found. It is the caller's responsibility to close this stream once it is no longer needed.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceAsStream(String)`

### getResourceObject

    Object getResourceObject(String aKey)
                             throws AnnotatorContextException

  Retrieves the named resource object. This can be used to acquire references to external resources. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
  Returns:
    the object bound to `aName`, `null` if none.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceObject(String)`

### getResourceURL

    URL getResourceURL(String aKey,
                       String[] aParams)
                       throws AnnotatorContextException

  Retrieves the URL to the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  Note that if the URL contains spaces may be encoded as %20. The `URL.getPath()` method does NOT decode these sequences, therefore it is not safe to call `getResourceURL().getPath()` and attempt to use the result as a file path. Instead, you may use `getResourceURI(String)` or `getResourceFilePath(String)`.

  For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  This version of this method takes an array of parameters used to further identify the resource. This can be used, for example, with resources that vary depending on the language of the document being analyzed, such as when the <fileLanguageResourceSpecifier> element is used in the component descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
    `aParams` - parameters used to further identify the resource. When used to identify the language for a <fileLanguageResourceSpecifier>, this array should contain a single element, the ISO language code for the language of the document (e.g. "en", "de").
  Returns:
    the `URL` at which the named resource is located, `null` if the named resource could not be found.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceURL(String,String[])`

### getResourceURI

    URI getResourceURI(String aKey,
                       String[] aParams)
                       throws AnnotatorContextException

  Retrieves the URI to the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  This method is safer than `getResourceURL(String)` in its treatment of file paths containing spaces. This is because the `URI.getPath()` does perform URL decoding of that path (decoding %20 sequences to spaces) whereas `URL.getPath()` does not.

  For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  This version of this method takes an array of parameters used to further identify the resource. This can be used, for example, with resources that vary depending on the language of the document being analyzed, such as when the <fileLanguageResourceSpecifier> element is used in the component descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
  Returns:
    the `URI` at which the named resource is located, `null` if the named resource could not be found.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceURI(String,String[])`

### getResourceFilePath

    String getResourceFilePath(String aKey,
                               String[] aParams)
                               throws AnnotatorContextException

  Retrieves the absolute file path to the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  This only works if the resource is a local file. If the resource is not a local file (for example, it could be an `http` URL, then an exception will be thrown.

  URL decoding will be done on the file path, so it is safe to use this method for file paths that contain spaces.

  For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  This version of this method takes an array of parameters used to further identify the resource. This can be used, for example, with resources that vary depending on the language of the document being analyzed, such as when the <fileLanguageResourceSpecifier> element is used in the component descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
  Returns:
    the absolute file path at which the named resource is located, `null` if the named resource could not be found.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceFilePath(String,String[])`

### getResourceAsStream

    InputStream getResourceAsStream(String aKey,
                                    String[] aParams)
                                    throws AnnotatorContextException

  Retrieves an InputStream for reading from the named resource. This can be used, for example, to locate configuration or authority files. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  For backwards compatibility, if the key is not declared as a resource dependency, it is looked up directly in the `data path` and the class path. However, this usage is deprecated and support may be dropped in future versions. ALL external resource dependencies should be declared in the descriptor.

  This version of this method takes an array of parameters used to further identify the resource. This can be used, for example, with resources that vary depending on the language of the document being analyzed, such as when the <fileLanguageResourceSpecifier> element is used in the component descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should bd declared in the <externalResourceDependencies> section of the descriptor.
    `aParams` - parameters used to further identify the resource. When used to identify the language for a <fileLanguageResourceSpecifier>, this array should contain a single element, the ISO language code for the language of the document (e.g. "en", "de").
  Returns:
    an `InputStream` for reading from the named resource, `null` if the named resource could not be found. It is the caller's responsibility to close this stream once it is no longer needed.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceAsStream(String,String[])`

### getResourceObject

    Object getResourceObject(String aKey,
                             String[] aParams)
                             throws AnnotatorContextException

  Retrieves the named resource object. This can be used to acquire references to external resources. The resource should be declared in the <externalResourceDependencies> section of the descriptor.

  This version of this method takes an array of parameters used to further identify the resource. This can be used, for example, with resources that vary depending on the language of the document being analyzed, such as when the <fileLanguageResourceSpecifier> element is used in the component descriptor.

  Parameters:
    `aKey` - the key by which the resource is identified. This key should be declared in the <externalResourceDependencies> section of the descriptor.
    `aParams` - parameters used to further identify the resource. When used to identify the language for a <fileLanguageResourceSpecifier>, this array should contain a single element, the ISO language code for the language of the document (e.g. "en", "de").
  Returns:
    the object bound to `aName`, `null` if none.
  Throws:
    `AnnotatorContextException`
  See Also:
    `UimaContext.getResourceObject(String,String[])`

### getDataPath

    String getDataPath()
                       throws AnnotatorContextException

  Gets the data path used to locate resources. This path may contain more than one directory, separated by the System `path.separator` character (; on windows, : on UNIX).

  This method is intended to be used only for integration of legacy or third-party components that have their own resource management facility. If possible, it is recommended that you use the `getResoureXXX` methods instead.

  Returns:
    the data path
  Throws:
    `AnnotatorContextException` - if an internal failure has occurred in the `AnnotatorContext`.

### mapToSofaID

    SofaID mapToSofaID(String aSofaName)

  Deprecated. As of v2.0, annotators no longer need to explicitly call this method. CAS views can now be obtained directly by the method `CAS.getView(String)`, and the framework will automatically do the necessary Sofa mappings.

  Retrieve actual sofa ID given a symbolic name

  Parameters:
    `aSofaName` - this component's name for a SofA
  Returns:
    absolute SofA ID

### getSofaMappings

    SofaID[] getSofaMappings()

  Deprecated. As of v2.0, annotators no longer need to explicitly call this method. CAS views can now be obtained directly by the method `CAS.getView(String)`, and the framework will automatically do the necessary Sofa mappings.

  Returns:
    array of SofaID objects containing mapping of component sofa name to absolute sofa id

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 The Apache Software Foundation. All Rights Reserved.